<?php
if ( version_compare( $newarf_dig_sig_version, '1.9', '<' ) ) {
	global $wpdb,$MdlDb;

	$signatures = $wpdb->get_results( $wpdb->prepare( 'SELECT id,form_id,field_options FROM `' . $MdlDb->fields . '` WHERE type = %s', 'signature' ) );

	if ( $signatures ) {
		foreach ( $signatures as $key => $signature ) {

			$normal_css   = '';
			$material_css = '';

			$field_opts = json_decode( $signature->field_options, true );

			$form_id = $signature->form_id;

			if ( json_last_error() != JSON_ERROR_NONE ) {
				$field_opts = maybe_unserialize( $signature->field_options );
			}

			$image_width  = $field_opts['image_width'];
			$image_height = $field_opts['image_height'];

			$normal_css   .= '.ar_main_div_' . $form_id . ' .arf_field_' . $signature->id . ' .controls{ width:' . $field_opts['image_width'] . 'px; }';
			$material_css .= '.ar_main_div_' . $form_id . ' .arf_materialize_form .arf_field_' . $signature->id . ' .controls{ width:' . $field_opts['image_width'] . 'px; }';

			if( '' == $field_opts['image_height'] ){
				$field_opts['image_height'] = 150;
			}

			$img_height = (((int)$field_opts['image_height']) + 50);

			$normal_css   .= '.ar_main_div_' . $form_id . ' .arf_field_' . $signature->id . ' div.arf_dig_sig_pad{ width:' . $field_opts['image_width'] . 'px; height:' . $field_opts['image_height'] . 'px; }';
			$material_css .= '.ar_main_div_' . $form_id . ' .arf_materialize_form .arf_field_' . $signature->id . ' div.arf_dig_sig_pad{ width:' . $field_opts['image_width'] . 'px; height:' . $img_height . 'px; }';

			$normal_css .= '.ar_main_div_' . $form_id . ' .arf_field_' . $signature->id . ' input.arf_signature_output_' . $signature->id . '{ position:absolute; top:0; left:0; z-index: -1; }';

			$material_css .= '.ar_main_div_' . $form_id . ' .arf_materialize_form .arf_field_' . $signature->id . ' input.arf_signature_output_' . $signature->id . '{ position:absolute; top:0; left:0; z-index: -1; }';

			$wp_upload_dir = wp_upload_dir();
			$dest_dir      = $wp_upload_dir['basedir'] . '/arforms/maincss/';

			$maincss_file = $dest_dir . 'maincss_' . $form_id . '.css';

			$maincss_material_file = $dest_dir . 'maincss_materialize_' . $form_id . '.css';

			WP_Filesystem();
			global $wp_filesystem;

			$normal_css_content = $wp_filesystem->get_contents( $maincss_file );

			$material_css_content = $wp_filesystem->get_contents( $maincss_material_file );

			$new_css_content = $normal_css_content . $normal_css;

			$new_material_css_content = $material_css_content . $material_css;

			$wp_filesystem->put_contents( $maincss_file, $new_css_content, 0777 );

			$wp_filesystem->put_contents( $maincss_material_file, $new_material_css_content, 0777 );
		}
	}
}

update_option( 'arf_dig_sig_version', '2.0' );

global $newarf_dig_sig_version;
$newarf_dig_sig_version = '2.0';