var arf_dig_actions = [];
"use strict";
window.signaturePad = [];
if (typeof(arf_add_action) == 'function') {
	function arf_add_dig_action( action_name, callback, priority ) {
		if ( ! priority ) {
			priority = 10;
		}

		if ( priority > 100 ) {
			priority = 100;
		}

		if ( priority < 0 ) {
			priority = 0;
		}

		if ( typeof arf_dig_actions[action_name] == 'undefined' ) {
			arf_dig_actions[action_name] = [];
		}

		if ( typeof arf_dig_actions[action_name][priority] == 'undefined' ) {
			arf_dig_actions[action_name][priority] = []
		}

		arf_dig_actions[action_name][priority].push( callback );
		if ( 'undefined' != typeof window.arf_actions ) {
			var arf_action_keys = Object.keys( window.arf_actions );
			if ( arf_action_keys.length > 0 ) {
				window.arf_actions[action_name] = arf_dig_actions[action_name];
			} else {
				window.arf_actions = arf_dig_actions;
			}
		}
	}
	arf_add_dig_action( 'reset_field_in_outsite','reset_field_in_outsite_sign',10 );
	function reset_field_in_outsite_sign(param){
		var object  = param[0];
		var result  = param[1];
		var form_id = jQuery( object ).find( '[data-id="form_id"]' ).val();

		var res         = '';
		res             = isJSON( result );
		var conf_method = '';
		var resmessage  = '';

		var data = jQuery.parseJSON( result );

		jQuery.each(
			data,
			function(i,e){
				if (i == "conf_method") {
					conf_method = e;
				}
				if (i == "message") {
					resmessage = e;
				}
			}
		);

		if (conf_method != "") {
			jQuery( ".ar_main_div_" + form_id ).find( ".arf_clear_pad" ).trigger( "click" );
		}
	}
} else {
	function reset_field_in_outsite(object,result){
		var form_id = jQuery( object ).find( '[data-id="form_id"]' ).val();

		var res         = '';
		res             = isJSON( result );
		var conf_method = '';
		var resmessage  = '';

		var data = jQuery.parseJSON( result );

		jQuery.each(
			data,
			function(i,e){
				if (i == "conf_method") {
					conf_method = e;
				}
				if (i == "message") {
					resmessage = e;
				}
			}
		);

		if (conf_method != "") {
			jQuery( ".ar_main_div_" + form_id ).find( ".arf_clear_pad" ).trigger( "click" );
		}
	}
}

function addsignaturefield(id)
{
	var type = 'signature';
	addnewfrmfield( id, type );
}
if (typeof(arf_add_action) == 'function') {
	arf_add_action( 'arf_initialize_control_from_outside','arf_initialize_control_from_outside_signature',10 );
	function arf_initialize_control_from_outside_signature(param){
		var field_id   = param[0];
		var arf_remove = param[1];
		var field_type = param[2];
		if (field_type == 'signature') {
			var field_data       = arf_retrieve_field_data( field_id );
			var signature_width  = field_data.image_width;
			var signature_height = field_data.image_height;
			jQuery( '#arfmainfieldid_' + field_id ).find( ".arf_signature_edior_img" ).css( 'width',signature_width );
			jQuery( '#arfmainfieldid_' + field_id ).find( ".arf_signature_edior_img" ).css( 'height',signature_height );
		}

	}
}

function arf_init_signature_class() {
	var arf_sig_canvas = document.getElementsByTagName( 'canvas' );
	var totalCanvas    = (null != arf_sig_canvas) ? arf_sig_canvas.length : 0;
	if ( totalCanvas > 0 ) {

		for ( var c = 0; c < totalCanvas; c++ ) {
			var current_canvas = arf_sig_canvas[c];
			var canvas_class   = current_canvas.getAttribute( 'class' );

			var canvas_id = current_canvas.getAttribute( 'id' );

			var canvas_fid = canvas_id.replace( 'arf_canvas_','' );

			var bgcolor = current_canvas.getAttribute( 'data-bgcolor' ) || '#fff';

			var pncolor = current_canvas.getAttribute( 'data-pencolor' ) || '#000';

			window.signaturePad[canvas_fid] = new SignaturePad(

				current_canvas,
				{

					backgroundColor:bgcolor,

					penColor:pncolor,

					onEnd:function(){

						var data = this.toDataURL();

						var field_id = this.canvas.getAttribute( 'data-id' );

						if ( null == field_id ) {

							var field_id = this.canvas.getAttribute( 'id' ).replace( 'arf_canvas_','' );

							jQuery( 'input[name="item_meta[' + field_id + ']"]' ).val( data );

						} else {

							document.getElementById( 'field_' + field_id ).value = data;

						}

					}

				}
			);

		}
	}
}

jQuery( document ).ready(
	function($){
		jQuery( 'canvas.arf_do_canvas_resize' ).each(
			function(){
				var $this         = jQuery( this );
				var bottom_sticky = $this.parents( '.arform_bottom_fixed_main_block_bottom ' ).length;
				var top_sticky    = $this.parents( '.arform_bottom_fixed_form_block_top' ).length;
				var left_sticky   = $this.parents( '.arform_bottom_fixed_form_block_left' ).length;
				var right_sticky  = $this.parents( '.arform_bottom_fixed_form_block_right' ).length;
				if ( 0 == bottom_sticky && 0 == top_sticky && 0 == left_sticky && 0 == right_sticky ) {
					$this.css( 'max-width','100%' );

					var parent       = $this.parent();
					var parentWidth  = parseInt( parent.css( 'width' ) );
					var parentHeight = parseInt( parent.css( 'height' ) );

					$this.css( 'max-width','' );

					this.width  = parentWidth;
					this.height = parentHeight;
				}
			}
		);
		jQuery( '.arf_clear_pad' ).each(
			function(){
				var title = jQuery( this ).attr( 'data-title' );
				if ( title !== undefined ) {
					if (typeof(jQuery( this ).popover) == 'function') {
						jQuery( this ).popover(
							{
								html: true,
								trigger: 'hover',
								placement: 'bottom',
								content: title,
								title: '',
								animation: false
							}
						);
					}
				}
			}
		);
		
		arf_init_signature_class();
	}
);

jQuery( document ).on(
	'click',
	'.arf_dig_sig_clear',
	function(){
		var dataId = jQuery( this ).attr( 'data-id' );
		if ( 'undefined' != typeof window.signaturePad[dataId] ) {
			var fid = window.signaturePad[dataId].canvas.getAttribute( 'data-id' );
			window.signaturePad[dataId].clear();
			jQuery( '#field_' + fid ).val( '' );
		} else {
			var dataId = jQuery( this ).find( 'img' ).attr( 'id' );
			var fid    = dataId.replace( 'arf_clear_signature_','' );
			window.signaturePad[fid].clear();
			jQuery( 'input[name="item_meta[' + fid + ']"]' ).val( '' );
		}
	}
);
